/*=====================================================================*/
/*    serrano/prgm/project/bigloo/fthread/src/DotNet/bglfmutex.cs      */
/*    -------------------------------------------------------------    */
/*    Author      :  Manuel Serrano                                    */
/*    Creation    :  Sat Mar  5 13:37:30 2005                          */
/*    Last change :  Fri Mar 11 11:05:59 2005 (serrano)                */
/*    Copyright   :  2005 Manuel Serrano                               */
/*    -------------------------------------------------------------    */
/*    Mutex implementation                                             */
/*=====================================================================*/

/*---------------------------------------------------------------------*/
/*    The package                                                      */
/*---------------------------------------------------------------------*/
using System;
using System.Threading;
using bigloo;

/*---------------------------------------------------------------------*/
/*    bglfmutex                                                        */
/*---------------------------------------------------------------------*/
namespace bigloo.fthread {
   public class bglfmutex : bigloo.mutex {
      private static Object sym_not_owned = bigloo.foreign.BUNSPEC;
      private static Object sym_abandoned = bigloo.foreign.BUNSPEC;
      private static Object sym_not_abandoned = bigloo.foreign.BUNSPEC;
      
      public static void setup() {
	 bigloo.mutex.amutex = new bglfmutex( bigloo.foreign.BUNSPEC );
	 sym_not_owned = bigloo.foreign.string_to_symbol( "not-owned" );
	 sym_abandoned = bigloo.foreign.string_to_symbol( "abandoned" );
	 sym_not_abandoned = bigloo.foreign.string_to_symbol( "not-abandoned" );
      }

      private Object specific = bigloo.foreign.BUNSPEC;

      public bglfmutex( Object n ) : base( n ) {
	 ;
      }

      protected override mutex create( Object name ) {
	 return new bglfmutex( name );
      }

      public override bool acquire_lock() {
	 base.acquire_lock();
	 return true;
      }

      public override bool release_lock() {
	 base.release_lock();
	 return true;
      }

      public static Object state( Object m ) {
	 return bigloo.foreign.BUNSPEC;
      }
   }
}
