;*=====================================================================*/
;*    .../bigloo/api/gstreamer/src/Llib/gstplugin-mixer.scm            */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Thu Jan 10 07:19:31 2008                          */
;*    Last change :  Wed Mar 26 16:07:12 2008 (serrano)                */
;*    Copyright   :  2008 Manuel Serrano                               */
;*    -------------------------------------------------------------    */
;*    GstMixer                                                         */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __gstreamer_plugin_gstmixer

   (include "gst.sch")
   
   (import  __gstreamer_gstreamer
	    __gstreamer_gstobject
	    __gstreamer_gstelement
	    __gstreamer_gstelementfactory
	    __gstreamer_gstpad
	    __gstreamer_gstpluginfeature
	    __gstreamer_gstcaps
	    __gstreamer_gststructure
	    __gstreamer_gstregistry)
   
    (export (class gst-mixer-track::gst-object
	       (flags::long
		read-only
		(get (lambda (o)
			($gst-mixer-track-get-flags
			 ($gst-mixer-track
			  (gst-mixer-track-$builtin o))))))
	       (label::string
		read-only
		(get (lambda (o)
			($gst-mixer-track-get-label
			 ($gst-mixer-track
			  (gst-mixer-track-$builtin o))))))
	       (max-volume::long
		read-only
		(get (lambda (o)
			($gst-mixer-track-get-max-volume
			 ($gst-mixer-track
			  (gst-mixer-track-$builtin o))))))
	       (min-volume::long
		read-only
		(get (lambda (o)
			($gst-mixer-track-get-min-volume
			 ($gst-mixer-track
			  (gst-mixer-track-$builtin o))))))
	       (num-channels::long
		read-only
		(get (lambda (o)
			($gst-mixer-track-get-num-channels
			 ($gst-mixer-track
			  (gst-mixer-track-$builtin o)))))))
	    
	    ($make-gst-mixer-track ::$gst-mixer-track ::obj)
	    (gst-mixer-track-has-flag? ::gst-mixer-track ::$gst-mixer-track-flags)
	    
	    (gst-registry-mixer-list::pair-nil #!optional registry)

	    (gst-mixer-find-track::obj ::gst-element ::bstring)
	    (gst-mixer-track-list::pair-nil ::gst-element)
	    (gst-mixer-volume::vector ::gst-element ::gst-mixer-track)
	    (gst-mixer-volume-set!::obj ::gst-element ::gst-mixer-track ::obj)
	    (gst-mixer-mute-set!::bool ::gst-element ::gst-mixer-track ::bool)
	    (gst-mixer-record-set!::bool ::gst-element ::gst-mixer-track ::bool)
;* 	    (gst-mixer-flags::symbol ::gst-element)                    */
	    )

    (extern (export $make-gst-mixer-track "bgl_gst_mixer_track_new")))

;*---------------------------------------------------------------------*/
;*    $make-gst-mixer-track ...                                        */
;*---------------------------------------------------------------------*/
(define ($make-gst-mixer-track mt::$gst-mixer-track finalizer)
   (instantiate::gst-mixer-track
      ($builtin ($gst-mixer-track->object mt))
      ($finalizer finalizer)))

;*---------------------------------------------------------------------*/
;*    gst-mixer-track-has-flag? ...                                    */
;*---------------------------------------------------------------------*/
(define (gst-mixer-track-has-flag? mt::gst-mixer-track flag)
   ($gst-mixer-track-has-flag?
    ($gst-mixer-track (gst-mixer-track-$builtin mt))
    flag))

;*---------------------------------------------------------------------*/
;*    gst-registry-mixer-list ...                                      */
;*---------------------------------------------------------------------*/
(define (gst-registry-mixer-list #!optional registry)
   (filter! (lambda (f)
	       (string=? (gst-element-factory-klass f) "Generic/Audio"))
	    (gst-registry-element-factory-list registry)))

;*---------------------------------------------------------------------*/
;*    gst-mixer-find-track ...                                         */
;*---------------------------------------------------------------------*/
(define (gst-mixer-find-track el track)
   ($gst-mixer-get-track ($gst-element (gst-element-$builtin el)) track el))

;*---------------------------------------------------------------------*/
;*    gst-mixer-track-list ...                                         */
;*---------------------------------------------------------------------*/
(define (gst-mixer-track-list el)
   ($gst-mixer-track-list ($gst-element (gst-element-$builtin el)) el))

;*---------------------------------------------------------------------*/
;*    gst-mixer-volume ...                                             */
;*---------------------------------------------------------------------*/
(define (gst-mixer-volume mixer track)
   ($gst-mixer-get-volume
    ($gst-element (gst-element-$builtin mixer))
    ($gst-mixer-track (gst-element-$builtin track))))
					  
;*---------------------------------------------------------------------*/
;*    gst-mixer-volume-set! ...                                        */
;*---------------------------------------------------------------------*/
(define (gst-mixer-volume-set! mixer track obj)
   ($gst-mixer-set-volume!
    ($gst-element (gst-element-$builtin mixer))
    ($gst-mixer-track (gst-element-$builtin track))
    obj))
					  
;*---------------------------------------------------------------------*/
;*    gst-mixer-mute-set! ...                                          */
;*---------------------------------------------------------------------*/
(define (gst-mixer-mute-set! mixer track flag)
   ($gst-mixer-set-mute!
    ($gst-mixer (gst-element-$builtin mixer))
    ($gst-mixer-track (gst-element-$builtin track))
    flag)
   flag)
					  
;*---------------------------------------------------------------------*/
;*    gst-mixer-record-set! ...                                        */
;*---------------------------------------------------------------------*/
(define (gst-mixer-record-set! mixer track flag)
   ($gst-mixer-set-record!
    ($gst-mixer (gst-element-$builtin mixer))
    ($gst-mixer-track (gst-element-$builtin track))
    flag)
   flag)

;; Not portable (does not work on the Nokia, too old version of Gstreamer?)
;*---------------------------------------------------------------------*/
;*    gst-mixer-flags ...                                              */
;*---------------------------------------------------------------------*/
;* (define (gst-mixer-flags mixer)                                     */
;*    (let ((flags ($gst-mixer-get-mixer-flags                         */
;* 		 ($gst-mixer (gst-element-$builtin mixer)))))          */
;*       (cond                                                         */
;* 	 ((=fx flags $gst-mixer-flag-none)                             */
;* 	  'none)                                                       */
;* 	 ((=fx (bit-and flags $gst-mixer-flag-auto-notification)       */
;* 	       $gst-mixer-flag-auto-notification)                      */
;* 	  'auto-notification)                                          */
;* 	 (else                                                         */
;* 	  'unknown))))                                                 */
	  
	  
